import es
import popuplib
import playerlib
import usermsg
import cPickle
import os.path
from clans import clans as clan

recommened = {}
already = []
def load():
    get_reco()
    clan.registerextension('clanrecommmend', 'Member recommmendation!')
    clanrecommmend = popuplib.create('clanrecommmend')
    clanrecommmend.addline('Recommmend Someone to Join LG') 
    clanrecommmend.addline('-------------')
    clanrecommmend.addline(' ')
    clanrecommmend.addline('You can only recommend')
    clanrecommmend.addline('someone once a day')
    clanrecommmend.addline('And one person once')
    clanrecommmend.addline(' ')
    clanrecommmend.addline('->1. Recommend Now!')
    clanrecommmend.addline(' ')
    clanrecommmend.addline('->2. View Recommend!')
    clanrecommmend.addline(' ')
    clanrecommmend.addline('-------------')
    clanrecommmend.addline('->8. Back') 
    clanrecommmend.addline('0. Cancel') 
    clanrecommmend.menuselect = clanrecommmend_menuselect

def unload():
    save_reco()

def es_map_start(ev):
    save_reco()

def clanrecommmend_menuselect(userid, choice, popupid):
    if choice == 1:
        if clan.ismember(userid):
            if not es.getplayersteamid(userid) in already:
                reco = popuplib.easymenu('reco', '_popup_choice', reco_menuselect) 
                reco.settitle('Select A Player To Recommmend To Lg') 
                for player in es.getUseridList():
                    if not clan.ismember(player):
                        reco.addoption(player, es.getplayername(player)) 
                reco.send(userid)
            else:
                es.tell(userid, 'You can only recommend once a day!')
    if choice == 2:
        if clan.isadmin(userid):
            sendrecommenedcount(userid)

def sendrecommenedcount(userid):
    recommenedcount = popuplib.easymenu('recommenedcount', '_popup_choice', recommenedcount_select) 
    recommenedcount.settitle('Players Who Were Recommened!') 
    for player in recommened:
        recommenedcount.addoption(player, '|   %s  - %s' % (recommened[player]['count'], recommened[player]['name'])) 
    recommenedcount.menuselect = recommenedcountback
    recommenedcount.send(userid)

def recommenedcountback(caller, select, menuname):
    if select == 10:
        popuplib.send('clanrecommmend', caller)


def recommenedcount_select(caller, target, menuname):
    recommenedcountprofile = popuplib.easymenu('recommenedcountprofile', '_popup_choice', recommenedcountprofile_select) 
    recommenedcountprofile.settitle('Players Who Recommened %s!' % recommened[target]['name']) 
    for player in recommened[target]['bywho']:
        recommenedcountprofile.addoption(player, '| %s' % recommened[target]['bywho'][player]) 
    recommenedcountprofile.send(caller)



def recommenedcountprofile_select(caller, select, menuname):
    if select == 10:
        popuplib.send('clanrecommmend', caller)


def reco_menuselect(caller, target, menuname):
    target = es.getplayersteamid(target)
    if target in recommened:
        if not es.getplayersteamid(caller) in recommened[target]['bywho']:
            recommened[target]['bywho'][es.getplayersteamid(caller)] = es.getplayername(caller)
            recommened[target]['name'] = es.getplayername(es.getuserid(target))
            recommened[target]['count'] += 1
            already.append(es.getplayersteamid(caller))
        else:
            es.tell(caller, 'You can only vote for one person once!')
    
    else:
        recommened[target] = {}
        recommened[target]['bywho'] = {}
        recommened[target]['bywho'][es.getplayersteamid(caller)] = es.getplayername(caller)
        recommened[target]['count'] = 1
        recommened[target]['name'] = es.getplayername(es.getuserid(target))
        already.append(es.getplayersteamid(caller))
    popuplib.send('clanrecommmend', caller)
def get_reco():
   a = es.getAddonPath('clans/extensions/recommend') + '/recommend.db'
   if os.path.isfile(a):
      global recommened
      pd = open(a)
      recommened = cPickle.load(pd)
      pd.close()

def save_reco():
   pd = open(es.getAddonPath('clans/extensions/recommend') + '/recommend.db', 'w')
   cPickle.dump(recommened, pd)
   pd.close()